#include "types.h"
#include "parse.h"
#include "stdlib.h"
#include "error.h"

#define ISLETTER(x) ((x>='a'&&x<='z')||(x>='A'&&x<='Z'))
#define ISNUMBER(x) (x>='0'&&x<='9')
#define ISLETNUM(x) (ISLETTER(x)||ISNUMBER(x)||x=='*'||x=='_'||x=='.')

//   

const char* getnexttok(const char* cmdline,char *buf)
{
  if(cmdline==0||*cmdline==0)
    return 0;
  while(!ISLETNUM(*cmdline))
    cmdline++;
  while(ISLETNUM(*cmdline))
    *buf++=*cmdline++;
  *buf=0;
  return cmdline;
}

int parse(fieldname *flds,int fldsmax,tablename *tbls,int tblmax,fieldname *ord,const char* cmdline)
{
  char buf[50];

  cmdline=getnexttok(cmdline,buf);
  if(_streq(buf,"select")==0)
  {
    seterror("cmd line must begin from 'select'");
    return 0;
  }

  while((cmdline=getnexttok(cmdline,buf))!=0&&!_streq(buf,"from"))
  {
    if(fldsmax--==0)
    {
      seterror("flelds overflow");
      return 0;
    }
    _strcpy(*flds++,buf);
  }
  while((cmdline=getnexttok(cmdline,buf))!=0&&!_streq(buf,"order"))
  {
    if(tblmax--==0)
    {
      seterror("tables overflow");
      return 0;
    }
    _strcpy(*tbls++,buf);
  }
  if((cmdline=getnexttok(cmdline,buf))==0||!_streq(buf,"by"))
  {
    seterror("order by not found");
    return 0;
  }
  if((cmdline=getnexttok(cmdline,buf))!=0)
  {
    _strcpy(*ord,buf);
  }
  return 1;
}
